﻿Public Class Matrix(Of T)
	Public ReadOnly Mtr As New List(Of List(Of T))
	Public Sub AddRow(items As IEnumerable(Of T))
		Mtr.Add(items.ToList)
	End Sub
	Default Public Property Item(yKey As T, xKey As T) As T
		Get
			Dim y = Mtr.FindIndex(Function(itm) itm(0).Equals(yKey)), x = Mtr(0).FindIndex(Function(itm) itm.Equals(xKey))
			Return Item(y, x)
		End Get
		Set(value As T)
			Dim y = Mtr.FindIndex(Function(itm) itm(0).Equals(yKey)), x = Mtr(0).FindIndex(Function(itm) itm.Equals(xKey))
			Item(y, x) = value
		End Set
	End Property
	Default Public Property Item(y As Integer, x As Integer) As T
		Get
			Return Mtr(y)(x)
		End Get
		Set(value As T)
			Mtr(y)(x) = value
		End Set
	End Property
	Public Function AllToString() As String
		Dim txt = New List(Of String)
		For Each rw In Mtr
			For Each col In rw
				txt.Add(String.Format(Globalization.CultureInfo.InvariantCulture, "{0,8}", col))
			Next
			txt.Add(CrLf)
		Next
		Return String.Concat(txt)
	End Function
End Class
